/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_ipi.h 572 2010-04-20 08:08:09Z ertl-honda $
 */

/*
 *  ץåֳߥɥ饤СAT91SKYEYEѡ
 */

#ifndef TOPPERS_TARGET_IPI_H
#define TOPPERS_TARGET_IPI_H

#include "at91skyeye.h"

/*
 *  ֹȳߥϥɥֹ
 */
#define INTNO_IPI_PRC1  (0x10000|IRQ_IPI)  /* ֹ */
#define INHNO_IPI_PRC1  (0x10000|IRQ_IPI)  /* ߥϥɥֹ */
#define INTPRI_IPI_PRC1 -2                 /* ͥ */

#define INTNO_IPI_PRC2  (0x20000|IRQ_IPI)  /* ֹ */
#define INHNO_IPI_PRC2  (0x20000|IRQ_IPI)  /* ߥϥɥֹ */
#define INTPRI_IPI_PRC2 -2                 /* ͥ */

#define INTNO_IPI_PRC3  (0x30000|IRQ_IPI)  /* ֹ */
#define INHNO_IPI_PRC3  (0x30000|IRQ_IPI)  /* ߥϥɥֹ */
#define INTPRI_IPI_PRC3 -2                 /* ͥ */

#define INTNO_IPI_PRC4  (0x40000|IRQ_IPI)  /* ֹ */
#define INHNO_IPI_PRC4  (0x40000|IRQ_IPI)  /* ߥϥɥֹ */
#define INTPRI_IPI_PRC4 -2                 /* ͥ */

/*
 * ץåֳߤ˻ѤCOMID
 */  
#define IPI_COMID   0

/*
 *  ץåֳߤȯ
 */
Inline void
target_ipi_raise(uint_t procid)
{
	sil_wrw_mem((void *)IPI_REG, ((procid << 16) | IPI_COMID));
}

/*
 *  ץåֳߤΥꥢ
 */
Inline void
target_ipi_clear(void)
{

}

#endif /* TOPPERS_TARGET_IPI_H */
